﻿using System;
using System.IO;
using System.Drawing;
using System.Windows.Forms;

namespace Aplikace {
    public partial class Gal : UserControl {
        string[] imgs;
        int currNum;
        Point originalSize;
        double ratioGlobal;
        public EventHandler CloseGal;
        bool slideshow = false;

        public Gal() {
            InitializeComponent();
        }
        public void GoToImg(int num) {
            try{
                currNum = num;
                Image img = Bitmap.FromFile(imgs[num]);
                originalSize = new Point(img.Width, img.Height);
                pbPic.Image = img;
                fitToSize();
                FileInfo fi = new FileInfo(imgs[num]);
                lblInfo.Text = "Obrázek č. "+(num + 1).ToString()+" - "+fi.Name + "   |  " + fileSizeToStr(fi.Length) + "   |   " + fi.LastWriteTime + "   |   " + originalSize.X + " x " + originalSize.Y;
            }catch{}
        }
        void fitToSize() {
            double ratio;
            try {
                if (chbAutosize.Checked) {
                    if ((double)pnlScroll.Width / originalSize.X < (double)pnlScroll.Height / originalSize.Y) // vadí mi šířka
                        ratio = (double)pnlScroll.Width / (double)originalSize.X;
                    else
                        ratio = (double)pnlScroll.Height / (double)originalSize.Y;
                    ratio *= 0.95;
                    ratioGlobal = ratio;
                }
                else
                    ratio = ratioGlobal;
                pbPic.Width = (int)(originalSize.X * ratio);
                pbPic.Height = (int)(originalSize.Y * ratio);
                btnAuto.Text = (Math.Round(ratio, 2)*100) + "%";
            }
            catch { }
            
        }
        
        string fileSizeToStr(long bytes) {
            string size = "0 Bytů";
            if (bytes >= 1048576)
                size = String.Format("{0:##.##}", bytes / 1048576) + " MB";
            else if (bytes >= 1024)
                size = String.Format("{0:##.##}", bytes / 1024) + " KB";
            else if (bytes > 0 && bytes < 1024)
                size = bytes.ToString() + " B";
            return size;
        }
        public void init(string[] imgs) {
            this.imgs = imgs;
        }
        public void btnFirst_Click(object sender, EventArgs e) {
            GoToImg(0);
        }
        public void btnPrev_Click(object sender, EventArgs e) {
            GoToImg((imgs.Length + currNum - 1) % imgs.Length);
        }

        public void btnNext_Click(object sender, EventArgs e) {
            GoToImg((currNum + 1) % imgs.Length);
        }

        public void btnLast_Click(object sender, EventArgs e) {
            GoToImg(imgs.Length - 1);
        }

        private void Gal_Resize(object sender, EventArgs e) {
            fitToSize();
        }

        public void btnPlus_Click(object sender, EventArgs e) {
            chbAutosize.Checked = false;
            ratioGlobal *= 1.5;
            fitToSize();
        }

        public void btnMinus_Click(object sender, EventArgs e) {
            chbAutosize.Checked = false;
            ratioGlobal /= 1.5;
            if (ratioGlobal < 0.1)
                ratioGlobal = 0.1;
            fitToSize();
        }

        public void btnAuto_Click(object sender, EventArgs e) {
            ratioGlobal = 1;
            chbAutosize.Checked = false;
            fitToSize();
        }

        private void chbAutosize_CheckedChanged(object sender, EventArgs e) {
            if (chbAutosize.Checked)
                fitToSize();
        }

        private void btnClose_Click(object sender, EventArgs e) {
            if (CloseGal != null)
                CloseGal.Invoke(this, new EventArgs()); 
            if (slideshow) {
                btnSlideshow.Text = "SlideShow";
                tmr.Stop();
                slideshow = false;
            }
        }

        private void btnSlideshow_Click(object sender, EventArgs e) {
            if (slideshow) {
                btnSlideshow.Text = "SlideShow";
                tmr.Stop();
                slideshow = false;
            }
            else {
                slideshow = true;
                btnSlideshow.Text = "Zastavit";
                chbAutosize.Checked = true;
                tmr.Start();
            }
        }

        private void tmr_Tick(object sender, EventArgs e) {
            GoToImg((currNum + 1) % imgs.Length);
        }
    }
}
